<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Add Content</title>
    <link rel="stylesheet" type="text/css" href="../static/style.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootswatch/4.3.1/flatly/bootstrap.min.css">

    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>

</head>
<body>

    <div class="sg-card">

        <div class="sg-card-content">

            <div style="float:left;width:50%;">
                <div class="sg-card-title">
                   <h1 style="font-size: 20px;">Enter content</h1>
                </div>
                <form class="add">
                    <textarea id="text-01" name="text-input"></textarea>
                    <button class="button" id="sentenceValidator"><span><b>Validate Input</b></span></button>
                    <button class="button" id="addSubmit"><span><b>Add Data to Database</b></span></button>

                </form>

                <script type="text/javascript">

                    $("#sentenceValidator").click(function(event){
                        event.preventDefault();
                         var inputTextData = $.trim($("#text-01").val());
                            if(inputTextData.length >1){
                              $.post("/validateSentence", {
                                    sent: inputTextData
                                }).done(function(data) {
                                   $.trim($("#text-01").val(data));
                                });
                            }else{
                                const warning = addNotification(NOTIFICATION_TYPES.WARNING, 'Please enter valid sentence.');
                                setTimeout(() => {
                                    removeNotification(warning);
                                }, 5000);
                            }
                    });

                    $( "#addSubmit" ).click(function( event ) {
                          event.preventDefault();
                          var inputTextData = $.trim($("#text-01").val());
                            if(inputTextData.length >1){
                              $.post("/addData", {
                                    textData: inputTextData
                                }).done(function(data) {
                                    if(data == "success"){
                                        const info = addNotification(NOTIFICATION_TYPES.SUCCESS, 'Data successfully Added to the system.');
                                        setTimeout(() => {
                                            removeNotification(info);
                                        }, 5000);
                                        $("#text-01").val("")
                                    }else{
                                            const danger = addNotification(NOTIFICATION_TYPES.DANGER, 'Something went wrong. Please contact system administrator.');
                                            setTimeout(() => {
                                                removeNotification(danger);
                                            }, 5000);
                                        }

                                });
                            }else{
                                const warning = addNotification(NOTIFICATION_TYPES.WARNING, 'Please enter valid sentence.');
                                setTimeout(() => {
                                    removeNotification(warning);
                                }, 5000);
                            }
                        });
                </script>
            </div>
            <div style="float:right;width:47%;">
                <div class="sg-card-title">
                    <h1 style="font-size: 20px;">Rules</h1>
                </div>
                <div class="sg-card-content">

                    <ul>
                        <li><b>Rule 1: </b> Please enter valid <b> English words </b> without any spelling mistakes.</li>
                        <li><b>Rule 2: </b> Please enter meaningful sentence / sentences, check in grammarly before feeding the data into the system.</li>
                        <li><b>Rule 3: </b> Please complete the sentence with  <b>' . '</b></li>
                        <li><b>Rule 4: </b> Validate your input content by using <b> ' Validate input ' </b>button.</li>
                    </ul>

                </div>
<!--                <button class="button" id="trainModel" style="width:70%;margin-left:2.5rem;"><span><b>Click here to Train the model</b></span></button>-->
            </div>

            <div class="sg-table">
                <br>
                <br>
            <table class="table table-striped" id="table1">
			  	<thead class="thead-dark">
				    <tr>
				      <th scope="col">#</th>
				      <th scope="col">Id</th>
				      <th scope="col">Text</th>
				    </tr>
			  	</thead>
			  	<tbody id="table1-body">

			  	</tbody>
			</table>
            </div>


        </div>

    </div>

<div class="notification-container" id="notification-container">

</div>
<script src="static/bstable.js"></script>

	<script>
		var dataTable = new BSTable("table1",{
		editableColumns:"1,2",
		onEdit:function(data) {
				var $cols = data.find('td');
				//console.log($cols);
				ct=0;
				id = "";
				text = ""
				$cols.each(function($td) {
				    if(ct==0){
				        id = $cols[$td].innerText;
				    }else if(ct==1){
				        text = $cols[$td].innerText;
				    }
				    ct = ct +1;
				});
				$.post('/updateDataById',{
				    id: id,
				    text: text
				}).done(function(data){
				     if(data == "success"){
                        const SUCCESS = addNotification(NOTIFICATION_TYPES.SUCCESS, 'Successfully Edited');
                        setTimeout(() => {
                            removeNotification(SUCCESS);
                        }, 5000);
                    }else{
                        const danger = addNotification(NOTIFICATION_TYPES.DANGER, 'Something went wrong. Please contact system administrator.');
                        setTimeout(() => {
                            removeNotification(danger);
                        }, 5000);
                    }
				})
			},
			onBeforeDelete: function(button){
			      $row = $(button).parents('tr').prevObject;
			      $row.each(function(cell){
			        $cols = $($row[0]).find('td');
			        ct=0;
                    id = "";
                    $cols.each(function($td) {
                        if(ct==0){
                            id = $cols[$td].innerText;
                        }
                        ct = ct +1;
                    });
                    $.post('/deleteDataById',{
                            id: id
                        }).done(function(data){
                             if(data == "success"){
                                const SUCCESS = addNotification(NOTIFICATION_TYPES.SUCCESS, 'Successfully Deleted');
                                setTimeout(() => {
                                    removeNotification(SUCCESS);
                                }, 5000);
                            }else{
                                const danger = addNotification(NOTIFICATION_TYPES.DANGER, 'Something went wrong. Please contact system administrator.');
                                setTimeout(() => {
                                    removeNotification(danger);
                                }, 5000);
                            }
                        });
			      });
			},
			onDelete: function(button){
                dataTable.refresh();
			}
		});

		dataTable.init();

        $.get('/getData',{})
            .done(function(data) {
                rawData = JSON.parse(data);
                for(i=0;i<rawData.length;i++){
                    let row = document.createElement("tr");
                    row.innerHTML = `<th scope="row">` + (i+1) + `</th><td>`+rawData[i].id+`</td><td>` + rawData[i].text + `</td>`;
                    document.getElementById("table1-body").append(row);
                }
                 dataTable.refresh();
        });

        const notificationContainer = document.getElementById('notification-container');

        const NOTIFICATION_TYPES = {
            INFO: 'info',
            SUCCESS: 'success',
            WARNING: 'warning',
            DANGER: 'danger'
        };

        function addNotification(type, text) {
            const newNotification = document.createElement('div');
            newNotification.classList.add('notification', `notification-${type}`);

            const innerNotification = `<strong>${type} : </strong> ${text}`;

            newNotification.innerHTML = innerNotification;

            notificationContainer.appendChild(newNotification);

            return newNotification;
        }

        function removeNotification(notification) {
            notification.classList.add('hide');
            setTimeout(() => {
                notificationContainer.removeChild(notification);
            }, 500);
        }

        $("#trainModel").click(function(){
            $.post('/fetchNewData',{})
            .done(function(data) {
                if(data == "success"){
                    const SUCCESS = addNotification(NOTIFICATION_TYPES.SUCCESS, 'Successfully Loaded new data to the model.');
                    setTimeout(() => {
                        removeNotification(SUCCESS);
                    }, 5000);
                    $("#text-01").val("")
                }else{
                        const danger = addNotification(NOTIFICATION_TYPES.DANGER, 'Something went wrong. Please contact system administrator.');
                        setTimeout(() => {
                            removeNotification(danger);
                        }, 5000);
                    }

            });
        });

</script>
</body>
</html>